## cetic-6lbr 1.4.O

=== Makefile ===
CONTIKI_PROJECT = cetic-6lbr

# Default mode selection

CETIC_6LBR_SMARTBRIDGE=0
CETIC_6LBR_TRANSPARENTBRIDGE=0
CETIC_6LBR_ROUTER=0
CETIC_6LBR_6LR=0
CETIC_6LBR_ONE_ITF=0
CETIC_6LBR_LEARN_RPL_MAC=1

CONTIKI_WITH_IPV6 = 1

6LBR?=.

CONTIKI = $(6LBR)/../..

APPDIRS = $(6LBR)/apps $(6LBR)/../6lbr-demo/apps

PROJECTDIRS += $(6LBR) $(6LBR)/6lbr $(6LBR)/../6lbr-demo/apps/udp-client $(6LBR)/../6lbr-demo/apps/coap/rest-types

CFLAGS += -DPROJECT_CONF_H=\"project-conf.h\"

ifeq ($(TARGET),)
TARGET=native
endif

ifeq ($(6LBR_PLUGIN),)
$(CONTIKI_PROJECT):
endif

-include $(6LBR)/platform/$(TARGET)/Makefile.$(TARGET)
ifneq ("$(wildcard $(6LBR)/platform/$(TARGET)/6lbr-conf-$(TARGET).h)","")
CFLAGS+=-DCETIC_6LBR_PLATFORM_CONF=\"6lbr-conf-$(TARGET).h\"
endif

CFLAGS +=-DCETIC_6LBR_SMARTBRIDGE=$(CETIC_6LBR_SMARTBRIDGE)
CFLAGS +=-DCETIC_6LBR_TRANSPARENTBRIDGE=$(CETIC_6LBR_TRANSPARENTBRIDGE)
CFLAGS +=-DCETIC_6LBR_ROUTER=$(CETIC_6LBR_ROUTER)
CFLAGS +=-DCETIC_6LBR_6LR=$(CETIC_6LBR_6LR)
CFLAGS +=-DCETIC_6LBR_ONE_ITF=$(CETIC_6LBR_ONE_ITF)
CFLAGS +=-DCETIC_6LBR_LEARN_RPL_MAC=$(CETIC_6LBR_LEARN_RPL_MAC)

CONTIKI_WITH_RPL ?= 1
WITH_IP64?=1
WITH_TINYDTLS?=0
WITH_DTLSECHO?=0
WITH_DTLS_COAP?=0

ifeq ($(CETIC_6LBR_TRANSPARENTBRIDGE),1)
CONTIKI_WITH_RPL = 0
endif

ifeq ($(CETIC_6LBR_NDP_ROUTER),1)
CONTIKI_WITH_RPL = 0
endif

ifneq ($(WITH_WEBSERVER),0)
APPS+=6lbr-webserver
endif

ifneq ($(WITH_WEBSERVER_LITE),0)
APPS+=6lbr-webserver-lite
endif

ifneq ($(WITH_UDPSERVER),0)
APPS+=udp-server
endif

ifneq ($(WITH_UDPCLIENT),0)
CFLAGS += -DUDPCLIENT=1 -DUDP_CLIENT_AUTOSTART
PROJECT_SOURCEFILES += udp-client.c
endif

ifneq ($(WITH_NODE_CONFIG),0)
APPS+=node-config
endif

ifneq ($(WITH_NODE_INFO),0)
APPS+=node-info
endif

ifneq ($(WITH_NVM_PROXY),0)
APPS+=nvm-proxy
endif

ifneq ($(WITH_DNS_PROXY),0)
APPS+=dns-proxy
endif

ifneq ($(WITH_COAPSERVER),0)
APPS += er-coap rest-engine coap
endif

ifneq ($(WITH_TINYDTLS), 0)
APPS += tinydtls
CFLAGS += -DWITH_TINYDTLS=1
PROJECTDIRS+=$(CONTIKI)/apps/tinydtls/aes $(CONTIKI)/apps/tinydtls/sha2 $(CONTIKI)/apps/tinydtls/ecc
endif

ifneq ($(WITH_DTLSECHO), 0)
CFLAGS += -DWITH_DTLS_ECHO=1
PROJECTDIRS += $(6LBR)/../6lbr-demo/apps/dtls-echo
PROJECT_SOURCEFILES += dtls-echo.c
endif

PROJECT_SOURCEFILES += log-6lbr.c rio.c packet-filter.c sicslow-ethernet.c nvm-config.c llsec-wrapper.c mac-wrapper.c
MODULES += core/net/llsec/noncoresec

ifeq ($(WITH_IP64),1)
MODULES += core/net/ip64 core/net/ip64-addr
PROJECT_SOURCEFILES += ip64-eth-driver.c
endif

tools:
	cd tools && $(MAKE)

6lbr-demo:
	pushd test; ../package/usr/bin/6lbr conf-templates/cooja-1-router.conf; popd

all_native:
	@echo "Target is deprecated, use 'make TARGET=native all' instead"

all_econotag:
	@echo "Target is deprecated, use 'make TARGET=econotag all' instead"

all_red-io:
	@echo "Target is deprecated, use 'make TARGET=native all' instead"

all_cc2538dk:
	@echo "Target is deprecated, use 'make TARGET=cc2538dk all' instead"

all_zoul-eth-gw:
	@echo "Target is deprecated, use 'make TARGET=zoul-eth-gw all' instead"

include $(CONTIKI)/Makefile.include

.PHONY: all tools 6lbr-demo

=== test/Makefile ===
# General environment variables
SHELL=/bin/bash
CONTIKIDIR=../../..
COOJADIR=${CONTIKIDIR}/tools/cooja
COOJA_USER_CONFIG=~/.cooja.user.properties
COOJA_ROOT_CONFIG=/root/.cooja.user.properties
COOJA_CONFIG_SAMPLE=./conf-templates/cooja.user.properties.example

# COOJA generation
COOJAGEN=./coojagen

launch-6lbr-router-1-cooja:
	../package/usr/bin/6lbr conf-templates/cooja-1-router.conf

launch-6lbr-smartbridge-2br-cooja:
	@echo "*************************************************************************"
	@echo "* Creating bridge in LAZY mode, needs to be deleted manually at the end *"
	@echo "* Example:    ip link set br0 down                                      *"
	@echo "*             brctl delbr br0                                           *"
	@echo "*************************************************************************"
	../package/usr/bin/6lbr conf-templates/cooja-2-smartbridge-a.conf &
	../package/usr/bin/6lbr conf-templates/cooja-2-smartbridge-b.conf &

cooja-small: preset_1dag_10nodes.csc build-cooja config-cooja launch-cooja

cooja-2br-grid: grid_2br_3x6.csc build-cooja config-cooja launch-cooja

launch-cooja:
	java -jar ${COOJADIR}/dist/cooja.jar -quickstart=`cat ${COOJAGEN}/output/LASTFILE`

launch-cooja-nogui:
	java -jar ${COOJADIR}/dist/cooja.jar -nogui=`cat ${COOJAGEN}/output/LASTFILE`

%.csc: ${COOJAGEN}/examples/config_%.py
	python2.7 gensimfile.py $<

build-cooja: do-build-cooja serial2pty radiologger-headless

do-build-cooja:
	pushd ${COOJADIR}; ant jar; popd

config-cooja:
	if [ ! -f $(COOJA_USER_CONFIG) ]; then cp $(COOJA_CONFIG_SAMPLE) $(COOJA_USER_CONFIG); fi
	if [ `whoami` = root ] && [ ! -f $(COOJA_ROOT_CONFIG) ] ; then cp $(COOJA_CONFIG_SAMPLE) $(COOJA_ROOT_CONFIG); fi
	if ! grep -Fq "serial2pty" $(COOJA_USER_CONFIG) ; then sed -i "/^DEFAULT_PROJECTDIRS=/ s/\$$/\;\[APPS_DIR\]\/serial2pty/" $(COOJA_USER_CONFIG); fi
	if ! grep -Fq "radiologger-headless" $(COOJA_USER_CONFIG) ; then sed -i "/^DEFAULT_PROJECTDIRS=/ s/\$$/\;\[APPS_DIR\]\/radiologger-headless/" $(COOJA_USER_CONFIG); fi
	if [ `whoami` = root ] && ! grep -Fq serial2pty $(COOJA_ROOT_CONFIG) ; then sed -i "/^DEFAULT_PROJECTDIRS=/ s/\$$/\;\[APPS_DIR\]\/serial2pty/" $(COOJA_ROOT_CONFIG); fi
	if [ `whoami` = root ] && ! grep -Fq radiologger-headless $(COOJA_ROOT_CONFIG) ; then sed -i "/^DEFAULT_PROJECTDIRS=/ s/\$$/\;\[APPS_DIR\]\/radiologger-headless/" $(COOJA_ROOT_CONFIG); fi

serial2pty:
	pushd ${COOJADIR}/apps/serial2pty; echo $(JAVA_HOME); ant jar; popd

radiologger-headless:	
	pushd ${COOJADIR}/apps/radiologger-headless; ant jar; popd

clean-cooja-firmwares:
	cd ${COOJAGEN}/firmwares/6lbr-demo && $(MAKE) TARGET=sky clean
	cd ${COOJAGEN}/firmwares/6lbr-demo-delay && $(MAKE) TARGET=sky clean
	cd ${COOJAGEN}/firmwares/6lbr-demo-ndp && $(MAKE) TARGET=sky clean
	cd ${CONTIKIDIR}/examples/ipv6/slip-radio && $(MAKE) TARGET=sky clean
	cd ${COOJAGEN}/firmwares/6lbr-demo && $(MAKE) TARGET=cooja clean
	cd ${COOJAGEN}/firmwares/6lbr-demo-delay && $(MAKE) TARGET=cooja clean
	cd ${COOJAGEN}/firmwares/6lbr-demo-ndp && $(MAKE) TARGET=cooja clean
	cd ${CONTIKIDIR}/examples/ipv6/slip-radio && $(MAKE) TARGET=cooja clean

build-cooja-firmwares:
	cd ${COOJAGEN}/firmwares/6lbr-demo && $(MAKE) TARGET=sky
	cd ${COOJAGEN}/firmwares/6lbr-demo-delay && $(MAKE) TARGET=sky
	cd ${COOJAGEN}/firmwares/6lbr-demo-ndp && $(MAKE) TARGET=sky
	cd ${CONTIKIDIR}/examples/ipv6/slip-radio && $(MAKE) TARGET=sky

non-regression: nr-router nr-router-llsec nr-smartbridge nr-rpl-root-6lr nr-ndp-router nr-rpl-root-rpl-relay nr-multi-smartbridge nr-rpl-root-multi-rpl-relay nr-rpl-multi-6lr nr-result

nr-router:
	$(MAKE) preset_1dag_10nodes.csc
	python2.7 run_tests.py --scenarios NonRegressionScenarios --modes Router --log nr-router.log

nr-router-llsec:
	$(MAKE) preset_1dag_10nodes_llsec.csc
	python2.7 run_tests.py --scenarios NonRegressionScenarios --modes RouterLlsec --log nr-router.log

nr-smartbridge:
	$(MAKE) preset_1dag_10nodes.csc
	python2.7 run_tests.py --scenarios NonRegressionScenarios --modes SmartBridge --log nr-smartbridge.log

nr-rpl-root-6lr:
	$(MAKE) preset_1dag_10nodes.csc
	python2.7 run_tests.py --scenarios NonRegressionScenarios --modes RplRoot6lr --log nr-rpl-root-6lr.log

nr-ndp-router:
	$(MAKE) preset_1dag_1node.csc
	python2.7 run_tests.py --scenarios NonRegressionScenarios --modes NdpRouter --log nr-ndp-router.log

nr-rpl-root-rpl-relay:
	$(MAKE) preset_1dag_10nodes.csc
	python2.7 run_tests.py --scenarios NonRegressionScenarios --modes RplRootRplRelay --log nr-rpl-root-rpl-relay.log

nr-multi-smartbridge:
	$(MAKE) preset_2dags_20nodes_disjoint.csc
	python2.7 run_tests.py --scenarios MultiBrDisjointScenarios --modes MultiSmartBridge --log nr-multi-smartbridge-disjoint.log
	$(MAKE) grid_2br_3x6.csc
	python2.7 run_tests.py --scenarios MultiBrOverlapScenarios --modes MultiSmartBridge --log nr-multi-smartbridge-overlap.log

nr-rpl-root-multi-rpl-relay:
	$(MAKE) preset_2dags_20nodes_disjoint.csc
	python2.7 run_tests.py --scenarios MultiBrDisjointScenarios --modes RplRootMultiRplRelay --log nr-rpl-root-multi-rpl-relay-disjoint.log
	$(MAKE) grid_2br_3x6.csc
	python2.7 run_tests.py --scenarios MultiBrOverlapScenarios --modes RplRootMultiRplRelay --log nr-rpl-root-multi-rpl-relay-overlap.log

nr-rpl-multi-6lr:
	$(MAKE) preset_2dags_20nodes_disjoint.csc
	python2.7 run_tests.py --scenarios MultiBrDisjointScenarios --modes Multi6lr --log nr-rpl-multi-6lr-disjoint.log
	$(MAKE) grid_2br_3x6.csc
	python2.7 run_tests.py --scenarios MultiBrOverlapScenarios --modes Multi6lr --log nr-rpl-multi-6lr-overlap.log

nr-result:
	find report -name 'nr-*.log' | xargs head -6 | grep -v SUMMARY

=== tools/Makefile ===
CFLAGS+=-Wall -I../6lbr -I../platform/native -I../../6lbr-demo/apps/coap/ -I.

all: nvm_tool

nvm_tool: nvm_tool.c

clean:
	rm -f nvm_tool *.o

=== plugins/dummy/Makefile ===
6LBR_PLUGIN=dummy.so

6LBR=../..
PLUGIN_SOURCEFILES+=dummy.c

include $(6LBR)/Makefile

=== plugins/lwm2m-client/Makefile ===
6LBR_PLUGIN=lwm2m.so

6LBR=../..

PLUGIN_SOURCEFILES+=lwm2m-client.c

APPS+=$(6LBR)/../6lbr-demo/apps/lwm2m

PLUGIN_APPS+=lwm2m
PLUGIN_PROJECT_CONF=lwm2m-client.h

include $(6LBR)/Makefile

=== tools/econotag/Makefile ===
MC1322X := libmc1322x
BOARD=econotag
CFLAGS = -I$(MC1322X)/tests

# all off the common objects for each target
# a COBJ is made for EACH board and goes the obj_$(BOARD)_board directory
# board specific code is OK in these files
COBJS := put.o

# these targets are built with space reserved for variables needed by ROM services
# this space is initialized with a rom call to rom_data_init
TARGETS_WITH_ROM_VARS := 6lbr_nvm_flasher flasher

##################################################
# you shouldn't need to edit anything below here #
##################################################

# This Makefile includes the default rule at the top
# it needs to be included first
-include $(MC1322X)/Makefile.include

=== test/coojagen/firmwares/6lbr-demo-delay/Makefile ===
PROJECT=6lbr-demo-delay

CONTIKI=../../../../../..
PROJECTDIR=../../../../../6lbr-demo/

PROJECTDIRS+=$(PROJECTDIR)

WITH_SHELL=1
WITH_DELAY_IP=1
WITH_UDPCLIENT=1
WITH_WEBSERVER=0
WITH_COAPSERVER=0
UDP_PERIOD=5
WITH_UDP_CLIENT_AUTOSTART=0

include $(PROJECTDIR)/Makefile

=== test/coojagen/firmwares/6lbr-demo-ndp/Makefile ===
PROJECT=6lbr-demo-ndp

CONTIKI=../../../../../..
PROJECTDIR=../../../../../6lbr-demo/

PROJECTDIRS+=$(PROJECTDIR)

WITH_RPL=0

WITH_SHELL=1
WITH_DELAY_IP=0
WITH_UDPCLIENT=1
WITH_WEBSERVER=0
WITH_COAPSERVER=0
UDP_PERIOD=5
WITH_UDP_CLIENT_AUTOSTART=0

include $(PROJECTDIR)/Makefile

=== test/coojagen/firmwares/6lbr-demo/Makefile ===
PROJECT=6lbr-demo

CONTIKI=../../../../../..
PROJECTDIR=../../../../../6lbr-demo/

PROJECTDIRS+=$(PROJECTDIR)

WITH_SHELL=1
WITH_DELAY_IP=0
WITH_UDPCLIENT=1
WITH_WEBSERVER=0
WITH_COAPSERVER=0
UDP_PERIOD=5
WITH_UDP_CLIENT_AUTOSTART=0

include $(PROJECTDIR)/Makefile

=== debian/changelog ===
cetic-6lbr (1.4.O) unstable; urgency=low

  * Features
    Link layer Security
    NAT 64 / Dual stack
    RDNSS
    DNS Forwarder
    mDNS advertising
    Static port mapping
    Node Info (PRR, Hop Count, Parent Switch, ...)
  * Platform
    Zolertia Zoul/RE-Mote
    OpenMote
    CC26xx (experimental)
    OpenWRT
  * Network
    6lowpan context configuration (limited)
    RPL stability bugfixes
    Static route support
    Tap/bridge interface autoconfiguration
    RFC 4193 configuration script
  * Updates
    Rebased on Contiki 3.0
    TinyDTLS 1.9
    RFC CoAP
  * Development
    User plugins
    Out of tree development
    Modular webserver
    New configuration file
  * 6lbr-demo
    Simple Core Interface library
    CC26xx support
  * Simple Core Interface library ([draft-ietf-core-interfaces](https://tools.ietf.org/html/draft-ietf-core-interfaces-03))
    Observe binding support
    CoAP push binding support
    Runtime configurable binding
    Text, JSON, XML and SenML encoding
    Linked list, batch and linked batch support
    Simple Resource Directory client
    IPSO Application Framework demo
    LWM2M demo
  * Bugfixes
    Slip-Radio throughput improvements
    Fix CRC when Adress overriding is enabled
    CC2538DK alignment issues solved
    Loss of connectivity in SmartBridge mode
    Big Endian platform support
    Multi-dodag bugfixes
    Fix CSMA infinite retransmissions
    Various webserver glitches fixed
    Wrong month in logs fixed
    LLSEC reboot workaround
    Global DODAG id correction

 -- 6lbr-team <6lbr@cetic.be>  Thu, 12 May 2016 16:32:25 +0200

cetic-6lbr (1.3.3) unstable; urgency=low

  * 6LoWPAN/RPL
    Multi DODAG bugfixes
    Support DAG parameter updates
    Do not drop partially received segmented packets
  * Slip-Radio
    Better Z1 and CC2538 support
    Check message format
    Add more baud rates
  * Network
    Fix multicast snooping on bridge interface
    Fix bridge hw address
    Fix tap interface down issue
  * BeagleBone
    Add Debian support
    Add USB scanning issue workaround

 -- 6lbr-team <6lbr@cetic.be>  Fri, 08 May 2015 12:23:54 +0000

=== debian/control ===
Source: cetic-6lbr
Section: net
Priority: extra
Maintainer: 6LBR Team <6lbr@cetic.be>
Build-Depends: debhelper (>= 8.0.0)
Standards-Version: 3.9.3
Homepage: https://github.com/cetic/6lbr

Package: cetic-6lbr
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, bridge-utils
Description: CETIC 6LoWPAN Border Router
 CETIC 6LBR is an enhanced version of Contiki's 6LoWPAN Border Router solution.
 It provides network configuration and monitoring, and supports out of the box redundant and distributed operating modes.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

%:
	dh $@ 

override_dh_auto_build:
	make TARGET=native all
	make plugins
	make tools

# Add extra installation target for plugins
override_dh_auto_install:
	dh_auto_install -- plugins-install

override_dh_installinit:
	dh_installinit --onlyscripts --name 6lbr
